/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefEventFunction A function that allows to notify another device that a certain threshold value has been exceeded.
type SarefEventFunction interface {
	SarefFunction
	sarefHasThresholdMeasurementMultipleSarefMeasurement
	IsSarefEventFunction() bool // indicates base class
}

// sSarefEventFunction A function that allows to notify another device that a certain threshold value has been exceeded.
type sSarefEventFunction struct {
	propCommon
	propSarefHasCommandBaseSarefCommandTypeSarefNotifyCommandMultipleSarefNotifyCommand
	propSarefHasThresholdMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement
}

// NewSarefEventFunction creates a new SarefEventFunction
func (mod *Model) NewSarefEventFunction(iri string) (ret SarefEventFunction, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefEventFunction{}
	pc := propCommon{iri: iri, typ: "SarefEventFunction", model: mod}
	res.propCommon = pc
	mod.addSarefEventFunction(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefEventFunction) makeMaps() {
	res.sarefHasCommand = make(map[string]SarefNotifyCommand)
	res.sarefHasThresholdMeasurement = make(map[string]SarefMeasurement)
	return
}

// addSarefEventFunction adds SarefEventFunction to model
func (mod *Model) addSarefEventFunction(res SarefEventFunction) {
	mod.mSarefEventFunction[res.IRI()] = res
	mod.addSarefFunction(res)
	return
}

// SarefEventFunction returns all resources with given prefix
func (mod *Model) SarefEventFunction(prefix string) (res []SarefEventFunction) {
	for i := range mod.mSarefEventFunction {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefEventFunction[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefEventFunction) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#hasCommand":
		if v, ok := obj.(SarefCommand); ok {
			res.DelSarefHasCommand(v)
		}
	case "https://w3id.org/saref#hasThresholdMeasurement":
		res.propSarefHasThresholdMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.removeObject(obj)
	default:
	}
	return
}

// isSarefEventFunction indicates base class
func (res *sSarefEventFunction) IsSarefEventFunction() bool {
	return true
}

// isSarefFunction indicates base class
func (res *sSarefEventFunction) IsSarefFunction() bool {
	return true
}

// SetSarefHasCommand is setter of A relationship between an entity (such as a function) and a command
func (res *sSarefEventFunction) SetSarefHasCommand(in []SarefCommand) (err error) {
	temp := res.sarefHasCommand
	res.sarefHasCommand = make(map[string]SarefNotifyCommand)
	for i := range temp {
		temp[i].DelSarefIsCommandOf(res)
	}
	err = res.AddSarefHasCommand(in...)
	return
}

// AddSarefHasCommand adds A relationship between an entity (such as a function) and a command
func (res *sSarefEventFunction) AddSarefHasCommand(in ...SarefCommand) (err error) {
	for i := range in {
		if v, ok := in[i].(SarefNotifyCommand); ok {
			if _, ok := res.sarefHasCommand[v.IRI()]; !ok {
				res.sarefHasCommand[v.IRI()] = v
				v.AddSarefIsCommandOf(res)
			}
			continue
		}
		err = errors.New("Wrong SarefNotifyCommand type. Allowed types are [SarefNotifyCommand, ]")
	}
	return
}

// DelSarefHasCommand deletes A relationship between an entity (such as a function) and a command
func (res *sSarefEventFunction) DelSarefHasCommand(in ...SarefCommand) (err error) {
	for i := range in {
		if v, ok := in[i].(SarefNotifyCommand); ok {
			if _, ok := res.sarefHasCommand[v.IRI()]; !ok {
				delete(res.sarefHasCommand, v.IRI())
				v.DelSarefIsCommandOf(res)
			}
			continue
		}
		err = errors.New("Wrong SarefNotifyCommand type. Allowed types are [SarefNotifyCommand, ]")
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefEventFunction) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefEventFunction) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#hasCommand":
		if obj, ok := res.model.mSarefCommand[pred.Object.Term.String()]; ok {
			res.AddSarefHasCommand(obj)
		}
	case "https://w3id.org/saref#hasThresholdMeasurement":
		res.propSarefHasThresholdMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.init(res.model, pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefEventFunction) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#EventFunction", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefEventFunction) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefHasCommandBaseSarefCommandTypeSarefNotifyCommandMultipleSarefNotifyCommand.toGraph(node, g)
	res.propSarefHasThresholdMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefEventFunction) String() (ret string) {
	ret = res.iri + " " + "SarefEventFunction\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefEventFunction) propsString() (ret string) {
	ret = ""
	ret += res.propSarefHasCommandBaseSarefCommandTypeSarefNotifyCommandMultipleSarefNotifyCommand.String()
	ret += res.propSarefHasThresholdMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.String()
	return
}


